<img src="https://plugins.jetbrains.com/files/12693/65249/icon/pluginIcon_dark.svg" height="100" alt="Plugin's icon"/>

# Flutter Enhancement Suite

[![Build](https://github.com/marius-h/flutter_enhancement_suite/actions/workflows/build.yml/badge.svg)](https://github.com/marius-h/flutter_enhancement_suite/actions/workflows/build.yml)
[![Version](https://img.shields.io/jetbrains/plugin/v/12693-flutter-enhancement-suite.svg)](https://plugins.jetbrains.com/plugin/12693-flutter-enhancement-suite)
[![Downloads](https://img.shields.io/jetbrains/plugin/d/12693-flutter-enhancement-suite.svg)](https://plugins.jetbrains.com/plugin/12693-flutter-enhancement-suite)
[![Ratings](https://img.shields.io/jetbrains/plugin/r/rating/12693-flutter-enhancement-suite.svg)](https://plugins.jetbrains.com/plugin/12693-flutter-enhancement-suite)

<!-- Plugin description -->

The essential plugin for making working with Flutter easier than ever!
<p>
Easy-to-use tools for managing your pubspec.yaml, snippets & more
<p>

## Features

<h3>Autocomplete Pub Packages</h3>
<p>When you're adding a new package to your pubspec.yaml file, the plugin will figure out what you're looking for. When pressing enter the package with its current version number will appear magically!</p>
<p>
<img src="https://thumbs.gfycat.com/PastObviousAmericanquarterhorse-size_restricted.gif" width="400" alt="Autocomplete pub packages screenshot"/>
<p>

<h3>Update Pub Packages</h3>
<p>Whenever there's a new version available for a package, it will tell you. Just press <code>alt+⮐</code> or <code>⌥+⮐</code> and choose <em>"Update package"</em>.</p>
<p>
<img src="https://i.imgur.com/BEgj52a.png" width="400" alt="Update pub packages screenshot"/>
<p>

<h3>View Pub Package's Documentation</h3>
<p>Just hover over the package's name in the pubspec.yaml - it's as easy as that!</p>
<p>
<img src="https://i.imgur.com/Tlz9HCE.png" width="400" alt="View package's documentation screenshot"/>
<p>

<h3>View Pub Package's Changelog</h3>
<p>You want to update a package but don't know what has changed in the meantime?</p>
<p>No problem! Just hover over its version number to view the changelog.</p>
<p>
<img src="https://i.imgur.com/ks2i0Hx.png" width="400" alt="View package's changelog screenshot"/>
<p>

<h3>Open a package's page on pub.dev</h3>
<p>No more need to copy a package's name and pasting it into the searchbar on pub.dev!</p>
<p>No you can just get there by pressing <code>ctrl+B</code> or <code>⌘+B</code> while the cursor is on the package's name.</p>
<img src="https://i.imgur.com/K2jd8bN.png" width="400" alt="Open a package's page on pub.dev"/>
<p>

<h3>Quickly make classes, functions and variables private or public</h3>
<p>For all of you who got tired pressing <code>⇧+F6</code> and adding or removing the underscore: You're finally redeemed!</p>
<p>Just use <code>alt+⮐</code> or <code>⌥+⮐</code> to make it private or public.</p>
<img src="https://i.imgur.com/72tAvtf.png" width="400" alt="Quickly make classes, functions and variables private or public"/>
<p>

<h3>Generate Widgets</h3>
<p>When creating a new file, choose the <em>"New Flutter Widget"</em> option.
Enter the name for your widget and select its type.</p>
<p>
<img src="https://i.imgur.com/FKQtOVa.png" width="400" alt="Generate widgets screenshot"/>
<p>

<h3>Dart & Flutter Code Snippets</h3>
A bunch of snippets/LiveTemplates for quicker coding. Use <code>ctrl+Q</code> or <code>F1</code> when hovering over a snippet to get a preview of it.<br>
<ul>
    <li>Dart snippets (<a href="https://github.com/marius-h/flutter_enhancement_suite/blob/master/SNIPPETS.md#dart-code-snippets">Show snippets</a>)</li>
    <li>Flutter snippets (<a href="https://github.com/marius-h/flutter_enhancement_suite/blob/master/SNIPPETS.md#flutter-widget-snippets">Show snippets</a>)</li>
    <li>Flutter Hooks snippets (<a href="https://github.com/marius-h/flutter_enhancement_suite/blob/master/SNIPPETS.md#flutter-hooks-snippets">Show snippets</a>)</li>
</ul>
<p>

<h3>Icon Previews</h3>
<p>Preview icons from different icon packs in the sidebar.<br>

> <strong>Please note:</strong> This requires you to add the package <a href="https://pub.dev/packages/flutter_vector_icons">flutter_vector_icons</a> to your pub dependencies. The only compatible iconpacks for now are FontAwesome, Ionicons and MaterialCommunityIcons.</p>
<p>
<img src="https://i.imgur.com/JB9MkjA.png" width="400" alt="Icon previews screenshot"/>
<p>

<h3>Edit Linting Rules</h3>
<p>When viewing the <em>"analysis_options.yaml"</em> file, 
select the "Linter Rules Editor" tab at the bottom to see all linting options available.
</p>
<p>
<img src="https://i.imgur.com/kg9GeiY.png" width="400" alt="Edit linting rules screenshot"/>
<p>

<!-- Plugin description end -->

## :arrow_down:&nbsp;How to install?

You can install plugin directly from IntelliJ IDEA or Android Studio:

1. Open _Preferences_
2. Choose _Plugins_
3. Select the _Marketplace_ tab
4. Search for **Flutter Enhancement Suite**
5. Click on _install_

## :card_file_box:&nbsp;How can I contribute to this plugin?

* Create a [bug report](https://github.com/marius-h/flutter_enhancement_suite/issues/new?assignees=&labels=bug&template=i-encountered-a-bug-while-using-the-plugin.md&title=) when accounting a bug
* Create a [feature request](https://github.com/marius-h/flutter_enhancement_suite/issues/new?assignees=&labels=enhancement&template=i-d-like-to-request-a-feature.md&title=)
* Open up a [pull request](https://github.com/marius-h/flutter_enhancement_suite/pulls)
